// Copyright (C) 2002-2007 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __C_PARTICLE_ROTATION_AFFECTOR_H_INCLUDED__
#define __C_PARTICLE_ROTATION_AFFECTOR_H_INCLUDED__

#include "IParticleRotationAffector.h"
#include "SColor.h"

namespace irr
{
namespace scene
{

//! Particle Affector for attracting particles to a point
class CParticleRotationAffector : public IParticleRotationAffector
{
public:

	CParticleRotationAffector( f32 speedX = 5.0f, f32 speedY = 5.0f, f32 speedZ = 5.0f,
		core::vector3df point = core::vector3df(0.0f,0.0f,0.0f) );

	//! Affects a particle.
	virtual void affect(u32 now, SParticle* particlearray, u32 count);

	//! Set the point that particles will attract to
	virtual void setPivotPoint( core::vector3df point ) { PivotPoint = point; }

	//! Set the speed in degrees per second, for rotation around the X axis
	virtual void setSpeedX( f32 speed ) { SpeedX = speed; }

	//! Set the speed in degrees per second, for rotation around the Y axis
	virtual void setSpeedY( f32 speed ) { SpeedY = speed; }

	//! Set the speed in degrees per second, for rotation around the Z axis
	virtual void setSpeedZ( f32 speed ) { SpeedZ = speed; }

	//! Get the point that particles are attracted to
	virtual const core::vector3df& getPivotPoint() const { return PivotPoint; }

	//! Get the speed in degrees per second, for rotation around the X axis
	virtual const f32& getSpeedX() const { return SpeedX; }

	//! Set the speed in degrees per second, for rotation around the Y axis
	virtual const f32& getSpeedY() const { return SpeedY; }

	//! Set the speed in degrees per second, for rotation around the Z axis
	virtual const f32& getSpeedZ() const { return SpeedZ; }

    E_PARTICLE_AFFECTOR_TYPE getType() const { return EPAT_GRAVITY; }

    void serializeAttributes(io::IAttributes* out, io::SAttributeReadWriteOptions* options)
    {
//;        out->addColor("When", When);
    }

    s32 deserializeAttributes(s32 startIndex, io::IAttributes* in, io::SAttributeReadWriteOptions* options)
    {
/*
        const char* name = in->getAttributeName(startIndex);
        if (!name || strcmp(name, "When"))
            return startIndex; // attribute not valid
        When = in->getAttributeAsInt(startIndex);

        ++startIndex;
*/
        return startIndex;
    }

private:

	core::vector3df PivotPoint;
	f32 SpeedX;
	f32 SpeedY;
	f32 SpeedZ;
	u32 LastTime;
};

} // end namespace scene
} // end namespace irr


#endif // __C_PARTICLE_ROTATION_AFFECTOR_H_INCLUDED__

